//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet d'ajouter un device et de le lié à un user */
    public enum PostApiFoyerAjouterDevice {

        public static let service = APIService<Response>(id: "postApiFoyerAjouterDevice", tag: "Api Foyer", method: "POST", path: "/apiFoyer/ajouterDevice", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idFoyer: String

                public var uuid: String

                public init(idFoyer: String, uuid: String) {
                    self.idFoyer = idFoyer
                    self.uuid = uuid
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiFoyerAjouterDevice.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idFoyer: String, uuid: String) {
                let options = Options(idFoyer: idFoyer, uuid: uuid)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idFoyer"] = options.idFoyer
                params["UUID"] = options.uuid
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Void

            /** Succes */
            case status200

            public var success: Void? {
                switch self {
                case .status200: return ()
                }
            }

            public var response: Any {
                switch self {
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = .status200
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
